require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MATH_H)) {
    die("Never include <bits/math-vector.h> directly; include <math.h> instead.");
}
require 'bits/libm-simd-decl-stubs.ph';
if(defined (&__x86_64__)  && defined (&__FAST_MATH__)) {
    if(defined (&_OPENMP)  && (defined(&_OPENMP) ? &_OPENMP : undef) >= 201307) {
	eval 'sub __DECL_SIMD_x86_64 () { &_Pragma ("omp declare simd notinbranch");}' unless defined(&__DECL_SIMD_x86_64);
    }
 elsif( &__GNUC_PREREQ (6,0)) {
	eval 'sub __DECL_SIMD_x86_64 () { &__attribute__ (( &__simd__ ("notinbranch")));}' unless defined(&__DECL_SIMD_x86_64);
    }
    if(defined(&__DECL_SIMD_x86_64)) {
	undef(&__DECL_SIMD_cos) if defined(&__DECL_SIMD_cos);
	eval 'sub __DECL_SIMD_cos () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cos);
	undef(&__DECL_SIMD_cosf) if defined(&__DECL_SIMD_cosf);
	eval 'sub __DECL_SIMD_cosf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_cosf);
	undef(&__DECL_SIMD_sin) if defined(&__DECL_SIMD_sin);
	eval 'sub __DECL_SIMD_sin () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sin);
	undef(&__DECL_SIMD_sinf) if defined(&__DECL_SIMD_sinf);
	eval 'sub __DECL_SIMD_sinf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sinf);
	undef(&__DECL_SIMD_sincos) if defined(&__DECL_SIMD_sincos);
	eval 'sub __DECL_SIMD_sincos () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sincos);
	undef(&__DECL_SIMD_sincosf) if defined(&__DECL_SIMD_sincosf);
	eval 'sub __DECL_SIMD_sincosf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_sincosf);
	undef(&__DECL_SIMD_log) if defined(&__DECL_SIMD_log);
	eval 'sub __DECL_SIMD_log () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_log);
	undef(&__DECL_SIMD_logf) if defined(&__DECL_SIMD_logf);
	eval 'sub __DECL_SIMD_logf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_logf);
	undef(&__DECL_SIMD_exp) if defined(&__DECL_SIMD_exp);
	eval 'sub __DECL_SIMD_exp () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_exp);
	undef(&__DECL_SIMD_expf) if defined(&__DECL_SIMD_expf);
	eval 'sub __DECL_SIMD_expf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_expf);
	undef(&__DECL_SIMD_pow) if defined(&__DECL_SIMD_pow);
	eval 'sub __DECL_SIMD_pow () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_pow);
	undef(&__DECL_SIMD_powf) if defined(&__DECL_SIMD_powf);
	eval 'sub __DECL_SIMD_powf () { &__DECL_SIMD_x86_64;}' unless defined(&__DECL_SIMD_powf);
    }
}
1;
